/*****************************************************/
/* testabou.c                                        */
/* -- Test the about box.                            */
/*****************************************************/
#include <windows.h>
#include <windowsx.h>
#include "about.h"
#include "testabou.h"

char    szClass[]   = "TestAboutClass";
HFONT   hfnt;

LRESULT CALLBACK __export
  LwWndProc(HWND, UINT, WPARAM, LPARAM);

#ifdef __BORLANDC__
    #pragma argsused
#endif

int PASCAL
WinMain(HINSTANCE hins, HINSTANCE hinsPrev, LPSTR lpsz,
  int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    HWND    hwnd;
    MSG     msg;

    if (hinsPrev == NULL)
        {
        WNDCLASS    wcs;

        wcs.style = CS_HREDRAW | CS_VREDRAW;
        wcs.lpfnWndProc = LwWndProc;
        wcs.cbClsExtra = 0;
        wcs.cbWndExtra = 0;
        wcs.hInstance = hins;
        wcs.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        wcs.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcs.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcs.lpszMenuName =
          MAKEINTRESOURCE(idmTestAbout);
        wcs.lpszClassName = szClass;

        if (!RegisterClass(&wcs))
            return FALSE;
        }

    msg.wParam = 0;
    hfnt = CreateFont(-18, 0, 0, 0, FW_BOLD, TRUE, 0,
      0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
      CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
      DEFAULT_PITCH | FF_DONTCARE, "Arial");
    if ((hwnd = CreateWindow(szClass, "Test About",
      WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
      CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hins,
      NULL)) != NULL)
        {
        ShowWindow(hwnd, wShow);
        while (GetMessage(&msg, NULL, 0, 0))
            {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
            }
        }
    if (hfnt != NULL)
        DeleteObject(hfnt);
    return msg.wParam;
    }

LRESULT CALLBACK __export
LwWndProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lwParam)
/*****************************************************/
/* -- Main window procedure.                         */
/*****************************************************/
    {
    switch (wm)
        {
    default:
        break;

    case WM_DESTROY:
        PostQuitMessage(0);
        break;

    case WM_COMMAND:
        switch (wParam)
            {
        default:
            break;

        case idmAbout:
            {
            HINSTANCE   hins = GetWindowInstance(hwnd);
            HICON       hicn;

            hicn = LoadIcon(NULL, IDI_ASTERISK);
            FAbout(hins, hwnd, hicn,
              "Funky Test\tApp", hfnt,
              "\251 1993\tSome Software Development Company",
              "Sample credits\r\n"
              "Each line is terminated with \\r\\n\r\n"
              "Line 3\r\nLine 4\r\nLine 5\r\n"
              "Line 6\r\nLine 7\r\nLine 8",
              "About Funky Test App");
            DestroyIcon(hicn);
            }
            return 0;
            }
        break;
        }
    return DefWindowProc(hwnd, wm, wParam, lwParam);
    }
